<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Advanced CMS
'*********************************************************************************

'700 - Advanced CMS - Show Contents Category Name at Home Page's Box
'700 - 2010.05.05 - Enhancements: Content category able to be translated.
sub ShowContentBoxCatName(categoryid)
   if len(trim(categoryid))<= 0 then exit sub
   categoryid=cleanchars(categoryid)
   dim newsrs,strsql

   '701 - 2011.03.08 - Bug Fix: content category ncathide can be false
   strsql="select ncategoryid,ncatdescription from contentcategories where ncategoryid = "& categoryid &" and ncathide is null or ncathide = '' or ncathide = 'No' or ncathide = 'False'"
   
   Set newsrs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   '701 - 2011.03.15 - Enhancement: Speed up store performance
   newsrs.open strsql, dbc, adOpenForwardOnly, adLockReadOnly
   if not newsrs.eof then
	  response.write translatelanguage(dbc, "contentcategories", "ncatdescription","ncategoryid", newsrs("ncategoryid"), newsrs("ncatdescription"))
   else
	  response.write getlang("Langcontentcategorynorecord")
   end if
end sub

'700 - Advanced CMS - Show Contents Listing of specific category at Home Page's Box
sub ShowContentBox(categoryid,limit)
   if len(trim(categoryid))<= 0 then exit sub
   categoryid=cleanchars(categoryid)
   dim newsrs,strsql
   strsql="select distinct content.messagetype,content.contentid,content.nurllink,content.cdateadded,content.cNewsStartDate,content.cNewsEndDate from content left outer join concatcategories on content.contentid = concatcategories.intcatalogid"
   if instr(ucase(xdatabasetype), "MYSQL") > 0 or instr(ucase(xdatabasetype), "SQLSERVER") > 0 then
      strsql=strsql & " where content.hide = 0 and content.showonbox = 1"
   else
      strsql=strsql & " where content.hide = FALSE and content.showonbox = TRUE"
   end if
   strsql=strsql & " and concatcategories.intcategoryid = "& categoryid &""

   '700 - 2010.06.09 - Enhancement: Admin user activities, statstic, admin/front contents compatitable with adjustdate and adjusttime
   dim indatetime
   indatetime = getnowindate
   strsql = strsql & " and (cnewsStartDate is null or cnewsEndDate is null or (cnewsStartDate <= "& DateDelimit(indatetime) &" and cnewsEndDate >= "& DateDelimit(indatetime) &" )) "

   '700 - Customer Groups - Matching Custormer match
   strsql = strsql & GenerateCustomerMatchSQL ("content.contentgroups","content.excontentgroups","content.loggedin","and")
   
   dim customerid
   customerid=getsess("CustomerID")
   if customerid="" then customerid=-1
   strsql=strsql & getnewscustomersql(customerid, "content")

   '7.01 - 2010.10.05 - To support multistores to contents,blog,news
   if GetConfig("xproductmatch") = "Yes" then
      strsql = strsql & " and "
      GeneratecontentsProductmatchsql strsql
   end if
   
   '700 - 2010.06.28 - Enhancement: Information Box to be sorted alphabetically
   strsql = strsql & " ORDER BY content.messagetype"
   
   Set newsrs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   newsrs.open strsql, dbc, adOpenStatic, adLockOptimistic
   if newsrs.eof then
      '701 - 2011.11.01 - Bug Fix: Should not show message if no record found for content records at side boxes
      'response.write getlang("Langcontentcategorynorecord")
	  exit sub
   end if

   dim rc,newstemplate,checkdateflag
   newstemplate=getconfig("xcontentBoxTemplate")
   if newstemplate = "" then newstemplate="tmp_contentfrontbox.htm"
   
   dim runcnt,maxrecords
   runcnt = 1
   if isnumeric(limit) = true then maxrecords = limit
   if maxrecords = "" then maxrecords = 999
   
   while not newsrs.eof
      if runcnt <= cdbl(maxrecords) then
         showcontents newsrs,rc,newstemplate,"Yes",checkdateflag
  	     if rc>0 then exit sub
	  end if
	  runcnt = runcnt + 1
 	  newsrs.movenext
   wend
   closerecordset newsrs
end sub

' Generate customer match sql
function getnewscustomersql(customerid, passtype)
   select case ucase(passtype)
      case "CONTENT"
	     getnewscustomersql=" and (content.contactid = '"& customerid &"' or content.contactid = '' or content.contactid is null)"
	  case else
	     getnewscustomersql = ""
   end select
end function

sub showcontentcheckcontentgroups(strxcustomercontentgroups,customerid,newsrs,rc,template,frombox,checkdateflag)
   dim thegroups,group,thefieldgroups,fieldgroup,strcustsql,custrs,matchflag
   thegroups=split(replace(strxcustomercontentgroups," ",""),",")
   
   if len(trim(customerid))<=0 then exit sub

   strcustsql="select customercontentgroups from customers where contactid = "& customerid &""
   Set custrs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   '701 - 2011.03.15 - Enhancement: Speed up store performance
   custrs.open strcustsql, dbc, adOpenForwardOnly, adLockReadOnly
   if not custrs.eof then
	  if len(custrs("customercontentgroups"))>0 then
	     thefieldgroups=split(replace(custrs("customercontentgroups")," ",""),",")
		 matchflag=false
         for each group in thegroups
            for each fieldgroup in thefieldgroups
		       if lcase(group)=lcase(fieldgroup) then
			      matchflag=true
			      showcontents newsrs,rc,template,frombox,checkdateflag
				  exit for
			   end if
            next
			if matchflag=true then
			   exit for
			end if
         next
	  end if
   end if
   closerecordset custrs
end sub

sub showcontents(newsrs,rc,template,frombox,checkdateflag)
   dim xnewsBoxHeadLinesOnly

   if frombox="Yes" then
      xnewsBoxHeadLinesOnly=getconfig("xcontentBoxHeadLinesOnly")
   else
      xnewsBoxHeadLinesOnly="No"
   end if
   
   if xnewsBoxHeadLinesOnly="No" then
      if newsrs("nurllink")="" or isnull(newsrs("nurllink")) then
		 '701 - 2010.12.21 - Bug Fix: Blogs and News not translated correctly
		 ShopMergeTemplate "content", Template, newsrs("contentid"), "contentid"
      else
		 HtmlWrite "<li><a href="""& newsrs("nurllink") &""">"& translatelanguage(dbc, "content", "message","contentid", newsrs("contentid"), getmessage("content","contentid",newsrs("contentid"))) &"</a></li>"
      end if
   else
      if newsrs("nurllink")="" or isnull(newsrs("nurllink")) then
		 HtmlWrite "<li><a href=""shopcontent.asp?type=" & newsrs("messagetype") & """>"& translatelanguage(dbc, "content", "message","contentid", newsrs("contentid"), getmessage("content","contentid",newsrs("contentid"))) &"</a></li>"
      else
	     HtmlWrite "<li><a href="""& newsrs("nurllink") &""">"& translatelanguage(dbc, "content", "message","contentid", newsrs("contentid"), getmessage("content","contentid",newsrs("contentid"))) &"</a></li>"
  	  end if
   end if
end sub

function getmessage (dbtable,fieldname,passid)
   dim strsql,rs
   strsql="select message from "& dbtable &" where "& fieldname &" = " & passid
   Set rs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   '701 - 2011.03.15 - Enhancement: Speed up store performance
   rs.open strsql, dbc, adOpenForwardOnly, adLockReadOnly
   if not rs.eof then
      getmessage = rs("message")
   else
	  getmessage = ""
   end if
   closerecordset rs
end function

Sub Handle_ContentHeadLine (value, parsearray,parseRS)
   dim newsrs,thefieldname, thelngcontentid, thefieldtype, therc,strsql
   thefieldname="CONTENTID"
   
   '701 - 2011.02.16 - Enhancement: Speed enhancement
   thelngcontentid = parseRS(thefieldname)

   if thelngcontentid <> "" then
      strsql="select messagetype,message,nurllink from content where contentid = " & thelngcontentid
      Set newsrs = Server.CreateObject("ADODB.Recordset")
      '700 - 2010.09.26 - Enhancement: Speed up front store performance
      newsrs.open strsql, dbc, adOpenStatic, adLockOptimistic
	  if newsrs.eof then exit sub
      if newsrs("nurllink")="" or isnull(newsrs("nurllink")) then
         HtmlWrite "<a href='shopcontent.asp?contentid=" & thelngcontentid & "'>" & translatelanguage(dbc, "content", "message","contentid", thelngcontentid, newsrs("messagetype")) & "</a>"
      else
	     HtmlWrite "<a href='"& newsrs("nurllink") &"'>" & translatelanguage(dbc, "content", "message","contentid", thelngcontentid, newsrs("messagetype")) & "</a>"
      end if
      closerecordset newsrs
   end if
End Sub

Sub Handle_ContentMessageHome (value, parsearray,parseRS)
   dim newsrs,thefieldname, thelngcontentid, thefieldtype, therc,strsql
   thefieldname="CONTENTID"
   
   '701 - 2011.02.16 - Enhancement: Speed enhancement
   thelngcontentid = parseRS(thefieldname)

   if thelngcontentid <> "" then
      strsql="select message2 from content where contentid = " & thelngcontentid
      Set newsrs = Server.CreateObject("ADODB.Recordset")
      '700 - 2010.09.26 - Enhancement: Speed up front store performance
      newsrs.open strsql, dbc, adOpenStatic, adLockOptimistic
	  if newsrs.eof then exit sub
      if getconfig("xcontentfullstoryHomeBox") = "Yes" then
         HtmlWrite "" & translatelanguage(dbc, "content", "message2","contentid", thelngcontentid, newsrs("message2")) & ""
	  else
	     dim numchars
		 numchars = getconfig("xcontentsummarylengthHome")
		 if numchars = "" then
		    numchars = 100
		 end if
		 
		 '700 - 2010.07.19 - Enhancement: Add remove html checking at cms while translation
 	     HtmlWrite "" & left(CMSRemoveHTML(translatelanguage(dbc, "content", "message2","contentid", thelngcontentid, CMSRemoveHTML(newsrs("message2")))), numchars) & " ... "

		 HtmlWrite "<a href='shopcontent.asp?contentid=" & thelngcontentid & "'>" & getlang("langReadMore") & " &raquo;</a>"
	  end if
      closerecordset newsrs
   end if
End Sub

'generate news box
sub ShowNewsBox (limit)
end sub

sub shownewscheckcontentgroups(strxcustomercontentgroups,customerid,newsrs,rc,template,frombox,checkdateflag)
end sub

sub shownews(newsrs,rc,template,frombox,checkdateflag)
end sub

Sub Handle_NewsHeadLine (value, parsearray,parseRS)
End Sub

Sub Handle_NewsMessageHome (value, parsearray,parseRS)
End Sub

Sub Handle_NewsMessageHomeBox (value, parsearray,parseRS)
End Sub

sub ShowNewsHeadlines (howmanytimes)
end sub

sub Handle_NewsMessage (value, parsearray,parseRS)
end sub

sub  Handle_NewsReviewLinks (value, parsearray, parseRS)
end sub

sub displaynewscommentform
end sub

sub Handle_BlogsMessageHome (value, parsearray,parseRS)
End Sub

sub Handle_BlogsMessageHomeBox (value, parsearray,parseRS)
End Sub

Sub Handle_BlogsHeadLine (value, parsearray,parseRS)
End Sub

sub showblogs(blogsrs,rc,template,frombox,checkdateflag)
end sub

sub showblogscheckcontentgroups(strxcustomercontentgroups,customerid,blogsrs,rc,template,frombox,checkdateflag)
end sub

'generate blogs box
sub ShowBlogsBox (limit)
end sub

sub ShowBlogsHeadlines (howmanytimes)
end sub

sub Handle_BlogsMessage (value, parsearray,parseRS)
end sub

sub  Handle_BlogsReviewLinks (value, parsearray, parseRS)
end sub

sub displayblogscommentform
end sub

sub CreateCAPTCHA
   if getconfig("xprotectemailforms") <> "Yes" then exit sub
   htmlwrite "<div class=""captcha_wrapper"">"
   htmlwrite "<span class='fontbold'>" &  GetLang("langcaptchaenter") & "</span>"
   GetCAPTCHA
   htmlwrite "</div>"
end sub

sub Handle_translateblogs (value,parsearray, ParseRs)
end sub

sub Handle_translatenews (value,parsearray, ParseRs)
end sub

sub Handle_BlogsLink (value, parsearray,parseRS)
end sub

sub Handle_NewsLink (value, parsearray,parseRS)
end sub

sub SetupDynamicBlogs (dbc, ContentId, MessageType)
end sub

sub SetupDynamicNews (dbc, ContentId, MessageType)
end sub

'7.01 - 2010.10.05 - To support multistores to contents,blog,news
sub GeneratecontentsProductmatchsql (sql)
   dim shops(50), shopcount, i
   ParseRecord xproductmatch, shops, shopcount, "," ' get all shops allowed
   sql = sql & " ("
   for i = 0 to shopcount -1
      if i>0 then
         sql = sql & " or "
      end if
	  if instr(lcase(xdatabasetype),"mysql") > 0 then
	     sql = sql & " concat(',',productmatch,',') like '%," & shops(i) & ",%'"
	  else
	     sql = sql & " ',' + productmatch + ',' like "& sqlserverprefixn &"'%," & shops(i) & ",%'"
	  end if
   next
   sql = sql & " or (productmatch is null or productmatch = ''))"
end sub
%>