<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Mail routines
' CDONTS, ASPMAIL, JMAIL, ASPEMAIL,OCXMAIL, CDOSYS, DUNDAS
'*********************************************************************************

dim arrayemaillinks(50, 2) ' for use in emailing download links
dim arrayemaillinkscount

'700 - 2010.09.08 - Enhancment: Cover Old IIS issue
Assigncodepagevalue 65001

sub ExecuteMail(mailtype, My_from, myin_fromaddress, my_to, my_toaddress, my_subject, body, emailformat, Orderattachments, Orderattachmentcount)
   dim mailer
   dim mailerror
   dim htmlformat
   dim i
   dim my_fromaddress
   
   '701 - 2011.01.31 - Bug Fix: my_system should not be empty
   if trim(my_system) = "" then my_system = GetConfig("xemailsystem")

   '701 - 2011.01.12 - Improper character display to export
   body = replace(body, "&nbsp;", " ")
   body = replace(body, "&lt;", "<")
   body = replace(body, "&gt;", ">")
   my_subject = replace(my_subject, "&nbsp;", " ")
   my_subject = replace(my_subject, "&lt;", "<")
   my_subject = replace(my_subject, "&gt;", ">")
   
   my_fromaddress = myin_fromaddress
   ' should we force all emails to come from merchant
   if GetConfig("xmailfrommerchant") = "Yes" then
      my_fromaddress = GetConfig("xemail")
   end if
   htmlformat = ucase(emailformat)
   on error resume next
   if GetConfig("xdebug") = "Yes" then
      DebugWrite "to=" & my_to & "(" & my_toaddress &") from=" & my_from &"("& my_fromaddress &")"
      DebugWrite "attachments=" & orderattachmentcount
      DebugWrite body
   end if
   if ucase(mailtype) = "CDONTS" then
      set Mailer = Server.createobject("CDONTS.NewMail")
      if err.number<> 0 then
         mailerror = GetLang("langmailerror") & " " & mailtype
         HandleMailError mailerror
         exit sub
      end if
      Mailer.to = my_toaddress
      Mailer.From = my_from & " <" & my_fromaddress & ">"
      Mailer.Subject = my_subject
      Mailer.Body = body
      if htmlformat = "HTML" then
         Mailer.BodyFormat = 0
         Mailer.MailFormat = 0
      end if
      if Orderattachmentcount>0 then
         for i = 0 to orderattachmentcount -1
            Mailer.AttachFile orderattachments(i)
            if GetConfig("xdebug") = "Yes" then
               DebugWrite "adding " & orderattachments(i)
            end if
         next
         Orderattachmentcount = 0
      end if
      Mailer.Send
      set mailer = nothing
      exit sub
   end if
   if ucase(mailtype) = "ASPMAIL" then
      set Mailer = Server.createobject("SMTPsvg.Mailer")
      if err.number<> 0 then
         mailerror = GetLang("langmailerror") & " " & mailtype
         HandleMailError mailerror
         exit sub
      end if
      Mailer.AddRecipient my_to, my_toaddress
      Mailer.RemoteHost = my_system
      Mailer.FromName = my_from
      Mailer.FromAddress = my_fromAddress
      Mailer.Subject = my_subject
      Mailer.BodyText = body
      if htmlformat = "HTML" then
         Mailer.ContentType = "text/html"
      end if
      if Orderattachmentcount>0 then
         for i = 0 to orderattachmentcount -1
            Mailer.AddAttachment orderattachments(i)
         next
      end if
      if Mailer.SendMail then
         set Mailer = nothing
         exit sub
      else
         mailerror = GetLang("langmailerror") & " " & my_toaddress
         mailerror = mailerror & "<br />" & mailer.response
         HandleMailError mailerror
         set mailer = nothing
         exit sub
      end if
   end if
   if ucase(Mailtype) = "JMAIL" then
      set Mailer = Server.createobject("JMail.SMTPMail")
      if err.number<> 0 then
         mailerror = GetLang("langmailerror") & " " & mailtype
         HandleMailError mailerror
         exit sub
      end if

      '700 - 2010.05.11 - support utf8
      Mailer.Charset = "utf-8"

      Mailer.ServerAddress = my_system
      if GetConfig("xemailpassword")<>"" then
         mailer.mailserverpassword = GetConfig("xemailpassword")
      end if
      if GetConfig("Xemailuserid")<>"" then
         mailer.mailserverusername = GetConfig("xemailuserid")
      end if
      Mailer.Sender = my_fromAddress
      Mailer.SenderName = my_from
      Mailer.AddRecipient my_toaddress
      Mailer.Subject = my_subject

      if htmlformat = "HTML" then
         Mailer.ContentType = "text/html"
      end if
      Mailer.Body = body
      if Orderattachmentcount>0 then
         for i = 0 to orderattachmentcount -1
            Mailer.AddAttachment orderattachments(i)
         next
      end if
      if Mailer.execute then
         set Mailer = nothing
         exit sub
      else
         mailerror = GetLang("langmailerror") & " " & my_toaddress
         HandleMailError mailerror
         set mailer = nothing
         exit sub
      end if
   end if
   if ucase(Mailtype) = "ASPEMAIL" then
      set Mailer = Server.createobject("Persits.MailSender")
      '6.09 - Not handling mail errors at all
      if err.number<> 0 then
         mailerror = GetLang("langmailerror") & " " & mailtype
         HandleMailError mailerror
         exit sub
      end if

      '700 - 2010.08.12 - Enhancement: Support UTF8 to ASPEMAIL
      Mailer.CharSet = "UTF-8"
      Mailer.ContentTransferEncoding = "Quoted-Printable"
   
      Mailer.Host = my_system
      Mailer.From = my_fromAddress
      Mailer.FromName = my_from
      Mailer.AddAddress my_toaddress, my_to
      Mailer.Subject = my_subject
      if htmlformat = "HTML" then
         Mailer.IsHTML = TRUE
      end if
      if Orderattachmentcount>0 then
         for i = 0 to orderattachmentcount -1
            Mailer.AddAttachment orderattachments(i)
         next
      end if
      Mailer.Body = body
      if Mailer.Send then
         set Mailer = nothing
         exit sub
      else
         mailerror = GetLang("langmailerror") & " " & my_toaddress
         HandleMailError mailerror
         set mailer = nothing
         exit sub
      end if
   end if
   if ucase(Mailtype) = "OCXMAIL" then
      dim attach
      attach = ""
      set mailer = Server.createobject("ASPMAIL.ASPMailCtrl.1")
      '6.09 - Not handling mail errors at all
      if err.number<> 0 then
         mailerror = GetLang("langmailerror") & " " & mailtype
         HandleMailError mailerror
         exit sub
      end if
      if htmlformat = "HTML" then
         dim result
         result = Mailer.XHeader ("Content-Type", "text/html")
      end if
      if Orderattachmentcount>0 then
         attach = orderattachments(0)
         for i = 1 to orderattachmentcount -1
            attach = attach & "," & orderattachments(i)
         next
         mailerror = mailer.SMAttach(my_system, my_toaddress, my_fromaddress, my_subject, body, attach)
      else
         mailerror = mailer.SendMail(my_system, my_toaddress, my_fromaddress, my_subject, body)
      end if
      if "" = mailerror then
         set mailer = nothing
         exit sub
      else
         mailerror = GetLang("langmailerror") & " " & my_toaddress & VbCR & mailerror
         HandleMailError mailerror
         set mailer = nothing
      end if
      exit sub
   end if
   if ucase(Mailtype) = "DUNDAS" then
      set mailer = Server.createobject("Dundas.Mailer") 'Mailer object
      mailer.TOs.add my_toaddress, my_to
      mailer.Subject = my_subject
      mailer.SMTPRelayServers.add my_system
      mailer.FromAddress = my_fromaddress
      mailer.Fromname = my_from
      if htmlformat = "HTML" then
         Mailer.HTMLBody = body
      else
         mailer.Body = body
      end if
      if Orderattachmentcount>0 then
         for i = 0 to orderattachmentcount -1
            mailer.Attachments.add orderattachments(i)
         next
      end if
      mailer.SendMail
      'test for success/failure of the SendMail operation using VBScript's Err object
      if err.number <> 0 then
         'an error occurred so output the relevant error string
         mailerror = GetLang("langmailerror") & " " & my_toaddress & " The following error occurred: " & err.description
         HandleMailError mailerror
      end if
      set mailer = nothing 'release resources
      exit sub
   end if

   if ucase(Mailtype) = "JMAIL43" then
      set Mailer = Server.createobject("JMail.Message")
      if err.number<> 0 then
         mailerror = langmailerror & " " & mailtype
         HandleMailError mailerror
         exit sub
      end if

      '700 - 2010.11.16 - support utf8
      Mailer.Charset = "utf-8"

      Mailer.From = my_fromAddress
      Mailer.FromName = my_from
      Mailer.AddRecipient my_toaddress, my_to
      Mailer.Subject = my_subject

      '6.50.4 Bugs Fix - 08 October 2008
      if xemailpassword<>"" then
         mailer.mailserverpassword = xemailpassword
      end if
      if Xemailuserid<>"" then
         mailer.mailserverusername = xemailuserid
      end if
      if htmlformat = "HTML" then
         Mailer.HTMLBody = body
      else
         Mailer.Body = body
      end if
      if Orderattachmentcount>0 then
         for i = 0 to orderattachmentcount -1
            Mailer.AddAttachment orderattachments(i)
         next
      end if
      if Mailer.Send(my_system) then
         set Mailer = nothing
         exit sub
      else
         mailerror = langmailerror & " " & my_toaddress
         HandleMailError mailerror
         set mailer = nothing
         exit sub
      end if
   end if
   if ucase(mailtype) = "SOFTART" then
      set Mailer = Server.createobject("SoftArtisans.SMTPMail")
      if err.number<> 0 then
         mailerror = GetLang("langmailerror") & " " & mailtype
         HandleMailError mailerror
         exit sub
      end if
      Mailer.AddRecipient my_to, my_toaddress
      Mailer.RemoteHost = my_system
      Mailer.FromName = my_from
      Mailer.FromAddress = my_fromAddress
      Mailer.Subject = my_subject
      if htmlformat = "HTML" then
         Mailer.HTMLText = body
      else
         Mailer.BodyText = body
      end if
      if Orderattachmentcount>0 then
         for i = 0 to orderattachmentcount -1
            Mailer.AddAttachment orderattachments(i)
         next
      end if
      if Mailer.SendMail then
         set Mailer = nothing
         exit sub
      else
         mailerror = GetLang("langmailerror") & " " & my_toaddress
         mailerror = mailerror & "<br />" & mailer.response
         HandleMailError mailerror
         set mailer = nothing
         exit sub
      end if
   end if

   if ucase(mailtype) = "CDOSYS" then
      dim iConf
      dim Flds
      ' Send by connecting to port 2 of the SMTP server.
      const cdoSendUsingPort = 2
      set Mailer = createobject("CDO.Message")
      set iConf = createobject("CDO.Configuration")
	  Mailer.BodyPart.Charset = "UTF-8"
      Mailer.HTMLBodyPart.Charset = "UTF-8"
	  Mailer.TextBodyPart.Charset = "UTF-8"
      set Flds = iConf.Fields
      ' Set the CDOSYS configuration fields to use port 25 on the SMTP server.
      flds.item("http://schemas.microsoft.com/cdo/configuration/sendusing") = cdoSendUsingPort
      'ToDo: Enter name or IP address of remote SMTP server.
      flds.item("http://schemas.microsoft.com/cdo/configuration/smtpserver") = my_system
      flds.item("http://schemas.microsoft.com/cdo/configuration/smtpconnectiontimeout") = 10
	  
	  '701 - 2010.11.16 - to use default port 25
	  flds.Item("http://schemas.microsoft.com/cdo/configuration/smtpserverport") = 25

      '6.50 - add support for username and password
      if xmailusername > "" then
         flds.item("http://schemas.microsoft.com/cdo/configuration/smtpauthenticate") = 1
         flds.item("http://schemas.microsoft.com/cdo/configuration/sendusername") = xmailusername
      end if
      if xmailpassword > "" then
         flds.item("http://schemas.microsoft.com/cdo/configuration/sendpassword") = xmailpassword
      end if

      flds.Update
      'Apply the settings to the message.
      set Mailer.Configuration = iConf
      Mailer.to = my_toaddress 'ToDo: Enter a valid email address.
      Mailer.From = my_from & " <" & my_fromaddress & ">" 'ToDo: Enter a valid email address.
      Mailer.Subject = my_subject
      if Orderattachmentcount>0 then
         for i = 0 to orderattachmentcount -1
            Mailer.AddAttachment orderattachments(i)
         next
      end if
      if htmlformat = "HTML" then
         Mailer.HTMLBody = body
      else
         Mailer.TextBody = body
      end if
      Mailer.Send
      set Mailer = nothing
      set iConf = nothing
      exit sub
   end if
   mailerror = GetLang("langmailerror") & " " & mailtype
   HandleMailError mailerror
end sub

sub HandleMailerror (errormsg)
   SetSess "mailerror", errormsg
   if GetConfig("xDebug") = "Yes" then
      DebugWrite errormsg
   end if
end sub
%>