<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Invokes differnt XML or other HTTP utilities
' METHOD is POST or GET
' Shop Confgf xxmltype can be used as default
'*********************************************************************************

sub Shopxmlhttp (itype, iurl, indata, outdata, method, xmlerror)
   dim ucitype, url, ucmethod
   xmlerror = ""
   outdata = ""
   url = iurl
   ucmethod = ucase(Method)
   if ucmethod = "" then
      ucmethod = "POST"
   end if
   if ucmethod = "GET" then
      url = url & "?" & indata
   end if
   ucitype = ucase(Itype)
   if ucitype = "" then
      ucitype = GetConfig("xXMLtype")
      ucitype = ucase(ucitype)
   end if
   select case ucitype
      case "XML2"
         Shopxml2http url, indata, outdata, ucmethod, xmlerror
      case "XML3"
         Shopxml3http url, indata, outdata, ucmethod, xmlerror
      case "XML4"
         Shopxml4http url, indata, outdata, ucmethod, xmlerror
      case "DYNUHTTP"
         Shopdynuhttp url, indata, outdata, ucmethod, xmlerror
      case "ASPTEAR"
         Shopasptear url, indata, outdata, ucmethod, xmlerror
      case else
         outdata = "Unknown XML interface"
   end select
   if err.number<> 0 then
      xmlerror = err.description
      xmlerror = xmlerror & "<br />Using " & Itype
   end if
end sub

sub ShopASPTEAR( url, instr, outStr, method, xmlerror)
   dim tncurl, xobj, httpresp
   'CODE USED TO INTIALISE ASP TEAR
   const Request_POST = 1
   const Request_GET = 2
   set xobj = createobject("SOFTWING.ASPtear")
   Response.ContentType = "text/xml"
   if method = "POST" then
      httpResp = xobj.Retrieve(url, Request_POST, instr, "", "")
   else
      httpResp = xobj.Retrieve(url, Request_GET, "", "", "")
   end if
   set xobj = nothing
   outstr = httpresp
end sub

sub ShopDYNUHTTP( url, instr, outStr, method, xmlerror)
   dim myHttp, httpHdrs
   set myHttp = Server.createobject("DynuHttp.Http")
   myHttp.URL = url
   myHttp.QueryString = instr
   outstr = myHttp.GetURL()
   httpHdrs = myHttp.GetHeaders()
   set myHttp = nothing
end sub

' XML2
sub ShopXML2http(url, instr, outStr, method, xmlerror)
   on error resume next
   dim objhttp
   set objHttp = Server.createobject("Msxml2.ServerXMLHTTP")
   objHttp.open method, url, false

   'Set header fields
   objHttp.setRequestHeader "Content-Type", "application/x-www-form-urlencoded"
   objHttp.setRequestHeader "Content-Length", len(instr)

   if Method = "POST" then
      objHttp.Send instr
   else
      objHttp.Send
   end if

   outstr = objHttp.responseXml.xml
   set objhttp = nothing
end sub

' XML3
sub ShopXML3http(url, instr, outStr, method, xmlerror)
   dim objhttp
   set objhttp = Server.createobject ("Microsoft.XMLHTTP")
   objHttp.open method, url, false

   'Set header fields
   objHttp.setRequestHeader "Content-Type", "application/x-www-form-urlencoded"
   objHttp.setRequestHeader "Content-Length", len(instr)

   if Method = "POST" then
      objHttp.Send instr
   else
      objHttp.Send
   end if
   outstr = objHttp.responseXml.xml
   if (objHttp.status <> 200 ) then
      xmlerror = "Error Connecting Error code=" & objhttp.status
   end if
   set objhttp = nothing
end sub

' XML4
sub ShopXML4http(url, instr, outStr, method, xmlerror)
   dim objhttp
   set objhttp = Server.createobject ("MSXML2.ServerXMLHTTP.4.0")
   objHttp.open method, url, false

   'Set header fields
   objHttp.setRequestHeader "Content-Type", "application/x-www-form-urlencoded"
   objHttp.setRequestHeader "Content-Length", len(instr)

   if Method = "POST" then
      objHttp.Send instr
   else
      objHttp.Send
   end if
   outstr = objHttp.responseXml.xml
   set objhttp = nothing
end sub
%>